#define YYPARSE_PARAM parser
#define YYLEX_PARAM parser

//#define DEBUG
//#define DEBUGEXPR
#define DEBUGDATA
//#define DEBUGMEM

#define YYDEBUG         1
#define YYERROR_VERBOSE



void yyerror(void *,char *);
int yylex(void *,void *);
int yyparse(void *);


typedef struct linestruct
{
	struct linestruct *next;
	int line;
	char *the_str;
} LINE;

typedef struct variablestruct
{
	struct variablestruct *next;
	char name[40];
	int ivalue;
	double value;
	double fnvalue;
	char svalue[1024];
} VARIABLE;

typedef struct varliststruct
{
	VARIABLE *var[99];
	int qty;
} VARLIST;

typedef struct
{
	double values[99];
	int qty;
} EXPRLIST;

typedef struct
{
	long values[99];
	int qty;
} INTLIST;

typedef struct forloopstruct
{
	struct forloopstruct *next;
	LINE *ln;
	VARIABLE *var;
	double tolimit;
	double step;
	LINE *reline;
} NEXT;

typedef struct substruct
{
	struct substruct *next;
	LINE *returnline;
} SUB;

typedef struct openstruct
{
	struct openstruct *next;
	char name[40];
	FILE *fil;
	struct stat file_stat;
	int option_s;
	int option_d;
	int option_l;
	int option_r;
} OPEN;

typedef struct datastruct
{
	struct datastruct *next;
	int line;
	char *data;
} DATA;

typedef struct funcstruct
{
	struct funcstruct *next;
	char name[40];
	VARIABLE *placeholder;
	LINE *fnline;
} FUNC;

